<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { computed, ref } from 'vue';
import { storeToRefs } from 'pinia';
import { useScheduleStore } from '@/stores/schedule';
import type { post as postType } from '@/types/schedule';
import TextView from '@/components/general/TextView.vue';
import Embedded from '@/components/general/Embedded.vue';
import ElementDropdown from '@/components/schedule/ElementDropdown.vue';
import { handleModeEnum, userType } from '@/enums/enums';
import LikeButton from '@/components/general/LikeButton.vue';
import Modal from '@/components/general/Modal.vue';
import { getFileType } from '@/lib/utils';
import Button from '@/components/general/Button.vue';
import MagnifiedPost from '@/components/general/MagnifiedPost.vue';

const props = defineProps<{
    post: postType,
    postIndex: number,
    postCount: number,
    columnIndex: number,
    columnCount: number
}>();

const store = useScheduleStore();
const { getFullUsable, getMovable, getLikesAllowed, getCommentsAllowed, getStyle,
    handleMode, elementTitle, elementText, elementInfo, elementBody, showComments, postIndex, columnIndex, getUserType, elementColor } = storeToRefs(store);

const editPost = () => {
    handleMode.value = handleModeEnum.EDIT;
    elementTitle.value = props.post.title.headline;
    elementText.value = props.post.title.post;
    elementInfo.value = props.post.info ? props.post.info : '';
    elementBody.value = props.post.body;
    elementColor.value = props.post.color;
    postIndex.value = props.postIndex;
    columnIndex.value = props.columnIndex;
};

const likePostHandler = () => {
    if (getFullUsable)
        store.likePost({ columnIndex: props.columnIndex, postIndex: props.postIndex });
}

const openComments = () => {
    postIndex.value = props.postIndex;
    columnIndex.value = props.columnIndex;
    showComments.value = true;
}

const getCommentsLength = computed(() => {
    if (getUserType.value === userType.ADMIN || getUserType.value === userType.MODERATOR) {
        return props.post.comments.length;
    } else {
        return props.post.comments.filter((comment: any) => comment.visible).length;
    }
});

const changeVisibility = (value: boolean) => {
    store.editPostProps({ postIndex: props.postIndex, columnIndex: props.columnIndex, visible: value });
};

const submitAuthorization = () => {
    store.editPostProps({ postIndex: props.postIndex, columnIndex: props.columnIndex, authorized: true });
};

const rejectAuthorization = () => {
    store.deletePost({ postIndex: props.postIndex, columnIndex: props.columnIndex });
};

const isRejectDeleteModal = ref(false);
const showRejectDeleteModal = (value: boolean) => {
    isRejectDeleteModal.value = value;
};

const showTopbar = computed(() => {
    if (props.post.body) {
        if (props.post.title.post.toLowerCase().endsWith('.pdf'))
            return true;
        const fileType = getFileType(props.post.body, props.post.title.post)
        return (fileType && fileType !== 'misc' && fileType !== 'h5p') || (props.post.body.image && props.post.body.logo);
    }
    return false;
});

const isMagnifiedPostOpen = ref(false);
const handleShowMagnifiedPost = (value: boolean)=>{
    isMagnifiedPostOpen.value = value;
};

</script>
<template>
    <li class="bg-white text-gray-500 shadow-md flex flex-col gap-1 ml-1 mr-1 last:mb-4"
        :class="[post.shape, { 'outline-4 outline-dashed outline-red-500': !props.post.visible }]" :id="post.id"
        :style="{ background: post.color }">
        <div class="flex flex-row px-2 z-10"
            :class="['tb-' + post.shape, { 'post-handle cursor-grab': getFullUsable && getMovable }, { 'bg-white/80': showTopbar }]">
            <div class="min-h-7 p-1 hyphens-auto w-full max-h-7 text-ellipsis line-clamp-1" lang="de">
                <strong>{{ post.title.headline }}</strong>
            </div>
            <div class="ml-auto flex flex-row gap-0.5">
                <Tooltip :tooltip="$t('tooltips.expandPost')">
                    <button class="rounded-md hover:bg-gray-100 px-1 w-7 text-lg"
                        @click="()=>handleShowMagnifiedPost(true)"><i class="ri-expand-diagonal-line"></i></button>
                </Tooltip>
                <ElementDropdown :color="post.color" :shape="post.shape" :post="post" :postIndex="props.postIndex"
                    :postCount="postCount" :columnIndex="props.columnIndex" :columnCount="columnCount"
                    @edit="editPost" v-if="getFullUsable"/>
            </div>
        </div>
        <div class="-mt-8" v-if="post.body">
            <Embedded class="w-full" :key="post.title.post" :body="post.body" :url="post.title.post"
                :fontSize="getStyle.fontSize" :info="post.info" :topbarClass="'tb-' + post.shape"
                v-if="post.title.post && post.title.post.length > 0" />
        </div>
        <div class="" v-else>
            <TextView :fontSize="getStyle.fontSize" :content="post.title.post" @dblclick="editPost"
                v-if="post.title.post && getFullUsable" :font-style="getStyle?.font ? getStyle.font : ''"
                :content-length="-1" />
            <TextView :fontSize="getStyle.fontSize" :content="post.title.post" v-else-if="post.title.post"
                :font-style="getStyle?.font ? getStyle.font : ''" :content-length="-1" />
        </div>

        <div class="flex flex-row justify-between p-1"
            v-if="(getLikesAllowed || getCommentsAllowed) && post.authorized">
            <div class="w-fit">
                <LikeButton :likes="post.likes" :likeSymbol="getStyle.likeSymbol" @click="likePostHandler"
                    v-if="getLikesAllowed" />
            </div>
            <div class="w-fit">
                <Tooltip :tooltip="$t('tooltips.unhide')" v-if="(getUserType !== userType.USER && !props.post.visible)">
                    <button class="size-7 p-1 hover:bg-gray-100" @click="changeVisibility(true)"><i
                            class="ri-eye-off-line leading-5 text-[20px] text-teal-500"></i></button>
                </Tooltip>
            </div>
            <div class="w-fit">
                <Tooltip :tooltip="$t('contentPage.comment.label.pl')" v-if="getCommentsAllowed">
                    <button class="h-7 p-1 hover:bg-gray-100 select-none flex flex-row rounded-md"
                        @click="openComments">
                        <span class="text-xs leading-7 align-bottom"
                            v-if="getCommentsLength <= 99 && getCommentsLength > 0">{{
                            getCommentsLength }}</span>
                        <span class="text-xs leading-7 align-bottom" v-else-if="getCommentsLength > 99">99+</span>
                        <i class="ri-discuss-line leading-5 text-[20px]"></i>
                    </button>
                </Tooltip>
            </div>
        </div>
        <div class="flex justify-between w-full p-1" v-if="!post.authorized">
            <div class="w-12">
                <Tooltip :tooltip="$t('tooltips.reject')">
                    <Button variant="cancel" size="small" @click="showRejectDeleteModal(true)"><span><i
                                class="ri-close-line text-lg"></i></span></Button>
                </Tooltip>
            </div>
            <div class="w-12">
                <Tooltip :tooltip="$t('general.buttons.confirm')">
                    <Button variant="confirm" size="small" @click="submitAuthorization"><span><i
                                class="ri-check-line text-lg"></i></span></Button>
                </Tooltip>
            </div>
        </div>
        <Modal :labelSubmit="$t('adminMenu.pageDelete.submit')" :labelCancel="$t('general.buttons.cancel')"
            @submit="rejectAuthorization" @cancel="showRejectDeleteModal(false)"
            :text="$t('contentPage.post.deletePost')" :font="getStyle?.font ? getStyle.font : ''"
            v-if="isRejectDeleteModal"></Modal>
        <MagnifiedPost v-if="isMagnifiedPostOpen" @close="()=>handleShowMagnifiedPost(false)" :post="post"
            @like="likePostHandler" @comments="openComments" @visibility="changeVisibility" type="Schedule"
            :inert="showComments" :postIndex="props.postIndex" :columnIndex="props.columnIndex"/>
    </li>
</template>